package Maui;

#
# Copyright (c) 2002 Alex Martin <A.J.Martin@qmul.ac.uk>
#
# All rights reserved.  This program is free software;
# you can redistribute it and/or modify it under the same terms
# as Perl itself.

use 5.006;
use strict;
use warnings;
use Carp;

our $VERSION = '0.05';


package Maui::Msg;

require Maui;
require Exporter;
use AutoLoader;

our $CKSUM_SEED=0x1e17d32;
our $CLIENT="";

our %EXPORT_TAGS = ( 'all' => [ qw(
	checksum
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
);

sub new {
	my $class = shift;
	my $this = {
		TS     => time(),
		CLIENT => $CLIENT,
		AUTH   => getpwuid($>),
		@_
	};
	bless $this,$class;
	return $this;
}

sub send
{
	my ($this,$sock) = @_;
	my $dt;

	if ( ! exists $this -> {DT} ) {

		if ( exists $this -> {CMD} ){
			$this -> {DT} = "CMD=".$this->{CMD};
		} elsif ( exists $this -> {SC} ){
			$this -> {DT} = "SC=".$this->{SC};
		} else {
			print STDERR "Message invalid no CMD or SC\n";
			return -1;
		}
		if ( exists $this -> {ARG} ){
			$this -> {DT} .= " ARG=".$this->{ARG};
		} elsif ( exists $this -> {RESPONCE} ){
			$this -> {DT} .= " ARG=".$this->{RESPONCE};
		} else {
			print STDERR "Message invalid no ARG or RESPONCE\n";
			return -1;
		}
        }

	my $msg="TS=".$this->{TS}.
		" AUTH=".$this->{AUTH}.
		" CLIENT=".$this->{CLIENT}.
		" DT=".$this->{DT};
        checksum($msg,$this->{CK},$CKSUM_SEED);
	$msg = "CK=".$this->{CK}." ".$msg;
#	print "msg: $msg\n";
	printf $sock "%08d %s",length($msg),$msg,"\n";
	return 0;
}

sub receive
{
	my ($sock) = @_;
	my $len = <$sock>;
    print " len= $len \n";
	my $line;
	read $sock, $line, $len;
        print "Received line $line \n";
        my ($header,$dt) = split ( /\s+DT=/,$line,2);
	my @header = split (/\s+/,$header);
	my $thismsg={};
        foreach ( @header ){
        	my($key,$value)=split(/=/,$_);
                $thismsg -> { $key } = $value;
        }
	$thismsg->{'DT'} = $dt;
	my ($cmd,$arg) = split(/\s+/,$dt,2);
	my ($key,$val) = split(/=/,$cmd,2);
	$thismsg->{$key} = $val;
	($key,$val) = split(/=/,$arg,2);
	$thismsg->{$key} = $val;

	my $checkdata = $line;
	$checkdata =~ s/^CK=\w+\s+//;
	my $cksum;
	checksum($checkdata,$cksum,$CKSUM_SEED);
	if( $thismsg -> {CK} ne $cksum ){
		print "Invalid checksum ",$thismsg -> {CK}," expect ",$cksum,"\n";
		return 0;
	}
	bless $thismsg,'Scheduler::Maui::Msg';
	return $thismsg;
}


package Maui;
require Exporter;
require DynaLoader;
use AutoLoader;

our @ISA = qw(Exporter DynaLoader);

#enum {
#  oNONE = 0,
#  oJob,
#  oNode,
#  oRes,
#  oUser,
#  oGroup,
#  oAccount,
#  oPartition,
#  oScheduler,
#  oSystem,
#  oClass,
#  oQOS };

*oNONE      = \0;
*oJob       = \1;
*oNode      = \2;
*oRes       = \3;
*oUser      = \4;
*oGroup     = \5;
*oAccount   = \6;
*oPartition = \7;
*oScheduler = \8;
*oSystem    = \9;
*oClass     = \10;
*oQOS       = \11;


bootstrap Maui $VERSION;

sub cksum_seed{
	$CKSUM_SEED = shift;
}

1;
__END__
# Below is stub documentation for your module. You better edit it!

=head1 NAME

Maui - Perl interface to Maui scehduler

=head1 SYNOPSIS

  use Maui;

=head1 DESCRIPTION

Stub documentation for Checksum, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.


=head1 AUTHOR

Alex Martin<lt>a.j.martin@qmul.ac.uk<gt>

=head1 SEE ALSO

L<perl>.

=cut
